import pygtk
pygtk.require('2.0')
import gtk
import hildon
import os
import time
import threading
import gobject
import logging
import glob

gobject.threads_init()
gtk.gdk.threads_init()

FrameRate = []
Device = []
ViewFinder = gtk.DrawingArea()
SaveFile = []
Cycle = []
Folder = []
SaveConvertedFile = []
FrameRateConverted = []
Scale = []
MaxPics = []

def main():
    program = hildon.Program.get_instance()

win = hildon.Window()
win.set_title("PyTimelapse")
table = gtk.Table(5, 3, True)
win.add(table)

def toggle_viewfinder(widget): 
    if widget.get_active():
        threading.Thread(target = view_change).start()
        viewerbutton.set_label("Viewing...")
    else:
        viewerbutton.set_label("Viewing stopped")
	  cmd = "killall mplayer"
	  os.system(cmd)

def view_change():
    i = False
    while not i: 
        time.sleep(0.01)
        xid = ViewFinder.window.xid
        if Device[len(Device)-1] == "/dev/video1":
            cmd = "mplayer -vf mirror -wid "+str(xid)+" tv:// -tv driver=v4l2:device=/dev/video1"
            os.system(cmd)
        if Device[len(Device)-1] == "/dev/video0":
            cmd = "mplayer -wid "+str(xid)+" tv:// -tv driver=v4l2:device=/dev/video0"
            os.system(cmd)
        if viewerbutton.get_active() == 0:
            break

def selection_changed_framerate(select_framerate, data):
    current = select_framerate.get_current_text()
    FrameRate.append(current)
    frameratebutton.set_title("")

frameratebutton = hildon.PickerButton (gtk.HILDON_SIZE_AUTO_WIDTH | gtk.HILDON_SIZE_AUTO_HEIGHT, 
			hildon.BUTTON_ARRANGEMENT_HORIZONTAL)
select_framerate = hildon.TouchSelector(30)
#select_framerate.append_text("1")
#select_framerate.append_text("2")
#select_framerate.append_text("3")
select_framerate.append_text("4")
select_framerate.append_text("5")
select_framerate.append_text("6")
select_framerate.append_text("7")
select_framerate.append_text("8")
select_framerate.append_text("9")
select_framerate.append_text("10")
#select_framerate.append_text("11")
#select_framerate.append_text("12")
#select_framerate.append_text("13")
#select_framerate.append_text("14")
select_framerate.append_text("15")
#select_framerate.append_text("16")
#select_framerate.append_text("17")
#select_framerate.append_text("18")
#select_framerate.append_text("19")
select_framerate.append_text("20")
#select_framerate.append_text("21")
#select_framerate.append_text("22")
#select_framerate.append_text("23")
#select_framerate.append_text("24")
#select_framerate.append_text("25")
#select_framerate.append_text("26")
#select_framerate.append_text("27")
#select_framerate.append_text("28")
#select_framerate.append_text("29")
select_framerate.append_text("30")
select_framerate.connect("changed", selection_changed_framerate)
frameratebutton.set_title("Select framerate")
frameratebutton.set_selector(select_framerate)
table.attach(frameratebutton, 0, 1, 2, 3)

def selection_changed_device(select_device, data):
    current = select_device.get_current_text()
    if current == "Back Camera":
        Device.append("/dev/video0")
        devicebutton.set_title("")
    if current == "Front Camera":
        Device.append("/dev/video1")
        devicebutton.set_title("")

devicebutton = hildon.PickerButton (gtk.HILDON_SIZE_AUTO_WIDTH | gtk.HILDON_SIZE_AUTO_HEIGHT, 
			hildon.BUTTON_ARRANGEMENT_HORIZONTAL)
select_device = hildon.TouchSelector(2)
select_device.append_text("Back Camera")
select_device.append_text("Front Camera")
select_device.connect("changed", selection_changed_device)
devicebutton.set_title("Select device")
devicebutton.set_selector(select_device)
table.attach(devicebutton, 0, 1, 0, 1)

def save_file(self):
        window = gtk.Window()
        save_as = hildon.FileChooserDialog(window, gtk.FILE_CHOOSER_ACTION_SAVE)
        save_as.run()
        filename = save_as.get_filename()
        SaveFile.append(filename)
        save_as.hide()
        savebutton.set_title(filename)

def toggle_capture(widget): 
    if widget.get_active():
        #threading.Thread(target = capture_change).start()
        threading.Thread(target = automatic_capture).start()
        capturebutton.set_label("Capturing")
    else:
        capturebutton.set_label("Capture stopped")

def automatic_capture():
    s = int(FrameRate[len(FrameRate)-1])-3
    i = False
    c = 1
    if len(MaxPics) == 0:
        while not i:
            if Device[len(Device)-1] == "/dev/video0":
                viewerbutton.set_active(0)
                #cmd = "killall mplayer; gst-launch v4l2camsrc device=/dev/video0 num-buffers=1 ! ffmpegcolorspace ! videobalance brightness=0.2 contrast=1.5 ! gamma gamma=0.7 ! video/x-raw-yuv, width=800,height=480 ! jpegenc ! filesink location="+SaveFile[len(SaveFile)-1]+"`date +'%Y%m%d_%H%M%S'`.jpg"
                cmd = "killall mplayer; gst-launch v4l2camsrc device=/dev/video0 num-buffers=1 ! ffmpegcolorspace ! video/x-raw-yuv, width=800,height=480 ! jpegenc ! filesink location="+SaveFile[len(SaveFile)-1]+"`date +'%Y%m%d_%H%M%S'`.jpg"
                os.system(cmd)
                viewerbutton.set_active(1)
                Cycle.append(c)
                counterbutton.set_label(str(len(Cycle)))
                cmd = "sleep "+str(s)
                os.system(cmd)
            if Device[len(Device)-1] == "/dev/video1":
                viewerbutton.set_active(0)
                #cmd = "killall mplayer; gst-launch v4l2camsrc device=/dev/video1 num-buffers=1 ! ffmpegcolorspace ! videobalance brightness=0.5 contrast=1.6 ! gamma gamma=0.5 ! video/x-raw-yuv, width=640,height=480 ! jpegenc ! filesink location="+SaveFile[len(SaveFile)-1]+"`date +'%Y%m%d_%H%M%S'`.jpg"
                cmd = "killall mplayer; gst-launch v4l2camsrc device=/dev/video1 num-buffers=1 ! ffmpegcolorspace ! video/x-raw-yuv, width=640,height=480 ! jpegenc ! filesink location="+SaveFile[len(SaveFile)-1]+"`date +'%Y%m%d_%H%M%S'`.jpg"
                os.system(cmd)
                viewerbutton.set_active(1)
                Cycle.append(c)
                counterbutton.set_label(str(len(Cycle)))
                cmd = "sleep "+str(s)
                os.system(cmd)
            if capturebutton.get_active() == 0:
                break

    if len(MaxPics) > 0:
        while MaxPics[len(MaxPics)-1] > str(len(Cycle)):
            if Device[len(Device)-1] == "/dev/video0":
                viewerbutton.set_active(0)
                #cmd = "killall mplayer; gst-launch v4l2camsrc device=/dev/video0 num-buffers=1 ! ffmpegcolorspace ! videobalance brightness=0.2 contrast=1.5 ! gamma gamma=0.7 ! video/x-raw-yuv, width=800,height=480 ! jpegenc ! filesink location="+SaveFile[len(SaveFile)-1]+"`date +'%Y%m%d_%H%M%S'`.jpg"
                cmd = "killall mplayer; gst-launch v4l2camsrc device=/dev/video0 num-buffers=1 ! ffmpegcolorspace ! video/x-raw-yuv, width=800,height=480 ! jpegenc ! filesink location="+SaveFile[len(SaveFile)-1]+"`date +'%Y%m%d_%H%M%S'`.jpg"
                os.system(cmd)
                viewerbutton.set_active(1)
                Cycle.append(c)
                counterbutton.set_label(MaxPics[len(MaxPics)-1]+" / "+str(len(Cycle)))
                cmd = "sleep "+str(s)
                os.system(cmd)
            if Device[len(Device)-1] == "/dev/video1":
                viewerbutton.set_active(0)
                #cmd = "killall mplayer; gst-launch v4l2camsrc device=/dev/video1 num-buffers=1 ! ffmpegcolorspace ! videobalance brightness=0.5 contrast=1.6 ! gamma gamma=0.5 ! video/x-raw-yuv, width=640,height=480 ! jpegenc ! filesink location="+SaveFile[len(SaveFile)-1]+"`date +'%Y%m%d_%H%M%S'`.jpg"
                cmd = "killall mplayer; gst-launch v4l2camsrc device=/dev/video1 num-buffers=1 ! ffmpegcolorspace ! video/x-raw-yuv, width=640,height=480 ! jpegenc ! filesink location="+SaveFile[len(SaveFile)-1]+"`date +'%Y%m%d_%H%M%S'`.jpg"
                os.system(cmd)
                viewerbutton.set_active(1)
                Cycle.append(c)
                counterbutton.set_label(MaxPics[len(MaxPics)-1]+" / "+str(len(Cycle)))
                cmd = "sleep "+str(s)
                os.system(cmd)
        capturebutton.set_active(0)

def manual_capture(self):
    c = 1
    if Device[len(Device)-1] == "/dev/video1":
        viewerbutton.set_active(0)
        #cmd = "killall mplayer; gst-launch v4l2camsrc device=/dev/video1 num-buffers=1 ! ffmpegcolorspace ! videobalance brightness=0.5 contrast=1.6 ! gamma gamma=0.5 ! video/x-raw-yuv, width=640,height=480 ! jpegenc ! filesink location="+SaveFile[len(SaveFile)-1]+"`date +'%Y%m%d_%H%M%S'`.jpg"
        cmd = "killall mplayer; gst-launch v4l2camsrc device=/dev/video1 num-buffers=1 ! ffmpegcolorspace ! video/x-raw-yuv, width=640,height=480 ! jpegenc ! filesink location="+SaveFile[len(SaveFile)-1]+"`date +'%Y%m%d_%H%M%S'`.jpg"
        os.system(cmd)
        viewerbutton.set_active(1)
        Cycle.append(c)
        counterbutton.set_label(str(len(Cycle)))
    if Device[len(Device)-1] == "/dev/video0":
        viewerbutton.set_active(0)
        #cmd = "killall mplayer; gst-launch v4l2camsrc device=/dev/video0 num-buffers=1 ! ffmpegcolorspace ! videobalance brightness=0.2 contrast=1.5 ! gamma gamma=0.7 ! video/x-raw-yuv, width=800,height=480 ! jpegenc ! filesink location="+SaveFile[len(SaveFile)-1]+"`date +'%Y%m%d%H%M%S'`.jpg"
        cmd = "killall mplayer; gst-launch v4l2camsrc device=/dev/video0 num-buffers=1 ! ffmpegcolorspace ! video/x-raw-yuv, width=800,height=480 ! jpegenc ! filesink location="+SaveFile[len(SaveFile)-1]+"`date +'%Y%m%d%H%M%S'`.jpg"
        os.system(cmd)
        viewerbutton.set_active(1)
        Cycle.append(c)
        counterbutton.set_label(str(len(Cycle)))

def convert(self):
    win = hildon.Window()
    win.set_title("PyTimelapseMaker")
    table_convert = gtk.Table(4, 2, True)
    win.add(table_convert)
    folderbutton = hildon.Button (gtk.HILDON_SIZE_AUTO_WIDTH | gtk.HILDON_SIZE_AUTO_HEIGHT, 
			hildon.BUTTON_ARRANGEMENT_HORIZONTAL, "Select folder")
    def select_folder(self):
        window = gtk.Window()
        folder = hildon.FileChooserDialog(window, gtk.FILE_CHOOSER_ACTION_SELECT_FOLDER)
        folder.run()
        foldername = folder.get_filename()
        if glob.glob(foldername+"/*.jpg"):
            Folder.append(foldername)
            folder.hide()
            folderbutton.set_title(foldername)
        else:
            message = gtk.MessageDialog(type=gtk.MESSAGE_WARNING)
            message.set_markup("The selected folder doesn't contain jpg file(s). Please choose another folder!")
            message.show()
            folder.hide()
    folderbutton.connect("clicked", select_folder)
    table_convert.attach(folderbutton, 0, 1, 0, 1)

    save_convertedbutton = hildon.Button (gtk.HILDON_SIZE_AUTO_WIDTH | gtk.HILDON_SIZE_AUTO_HEIGHT, 
			hildon.BUTTON_ARRANGEMENT_HORIZONTAL, "Save as...")
    def save_file(self):
        window = gtk.Window()
        save_as = hildon.FileChooserDialog(window, gtk.FILE_CHOOSER_ACTION_SAVE)
        save_as.run()
        filename = save_as.get_filename()
        SaveConvertedFile.append(filename)
        save_as.hide()
        save_convertedbutton.set_title(filename)
    save_convertedbutton.connect("clicked", save_file)
    table_convert.attach(save_convertedbutton, 1, 2, 0, 1)

    framerate_convertedbutton = hildon.PickerButton (gtk.HILDON_SIZE_AUTO_WIDTH | gtk.HILDON_SIZE_AUTO_HEIGHT, 
			hildon.BUTTON_ARRANGEMENT_HORIZONTAL)
    select_framerateconverted = hildon.TouchSelector(30)
    select_framerateconverted.append_text("1")
    select_framerateconverted.append_text("2")
    select_framerateconverted.append_text("3")
    select_framerateconverted.append_text("4")
    select_framerateconverted.append_text("5")
    select_framerateconverted.append_text("6")
    select_framerateconverted.append_text("7")
    select_framerateconverted.append_text("8")
    select_framerateconverted.append_text("9")
    select_framerateconverted.append_text("10")
    select_framerateconverted.append_text("11")
    select_framerateconverted.append_text("12")
    select_framerateconverted.append_text("13")
    select_framerateconverted.append_text("14")
    select_framerateconverted.append_text("15")
    select_framerateconverted.append_text("16")
    select_framerateconverted.append_text("17")
    select_framerateconverted.append_text("18")
    select_framerateconverted.append_text("19")
    select_framerateconverted.append_text("20")
    select_framerateconverted.append_text("21")
    select_framerateconverted.append_text("22")
    select_framerateconverted.append_text("23")
    select_framerateconverted.append_text("24")
    select_framerateconverted.append_text("25")
    select_framerateconverted.append_text("26")
    select_framerateconverted.append_text("27")
    select_framerateconverted.append_text("28")
    select_framerateconverted.append_text("29")
    select_framerateconverted.append_text("30")
    def selection_changed_framerateconverted(select_framerateconverted, data):
        current = select_framerateconverted.get_current_text()
        FrameRateConverted.append(current)
    select_framerateconverted.connect("changed", selection_changed_framerateconverted)
    framerate_convertedbutton.set_title("Select framerate")
    framerate_convertedbutton.set_selector(select_framerateconverted)
    table_convert.attach(framerate_convertedbutton, 0, 1, 1, 2)

    scalebutton = hildon.PickerButton (gtk.HILDON_SIZE_AUTO_WIDTH | gtk.HILDON_SIZE_AUTO_HEIGHT, 
			hildon.BUTTON_ARRANGEMENT_HORIZONTAL)
    def selection_changed_scale(select_scale, data):
        current = select_scale.get_current_text()
        if current == "800x480":
            n900 = "w=800:h=480"
            Scale.append(n900)
        elif current == "400x240":
            mplayer = "w=400:h=240"
            Scale.append(mplayer)
    select_scale = hildon.TouchSelector(2)
    select_scale.append_text("800x480")
    select_scale.append_text("400x240")
    select_scale.connect("changed", selection_changed_scale)
    scalebutton.set_title("Select scale")
    scalebutton.set_selector(select_scale)
    table_convert.attach(scalebutton, 1, 2, 1, 2)

    convertbutton = hildon.Button (gtk.HILDON_SIZE_AUTO_WIDTH | gtk.HILDON_SIZE_AUTO_HEIGHT, 
			hildon.BUTTON_ARRANGEMENT_HORIZONTAL, "CONVERT")
    def convert(self): 
        cmd = "mencoder mf://"+Folder[len(Folder)-1]+"/*.jpg"+" -mf "+Scale[len(Scale)-1]+":fps="+FrameRateConverted[len(FrameRate)-1]+":type=jpg -ovc lavc -o "+SaveConvertedFile[len(SaveFile)-1]
        os.system(cmd)
    convertbutton.connect("clicked", convert)
    table_convert.attach(convertbutton, 0, 2, 2, 3)

    playbackbutton = hildon.Button (gtk.HILDON_SIZE_AUTO_WIDTH | gtk.HILDON_SIZE_AUTO_HEIGHT, 
			hildon.BUTTON_ARRANGEMENT_HORIZONTAL, "Playback")
    def playback(self):
        cmd = "mplayer -fs "+SaveConvertedFile[len(SaveFile)-1]
        os.system(cmd)
    playbackbutton.connect("clicked", playback)
    table_convert.attach(playbackbutton, 0, 2, 3, 4)
    win.show_all()

savebutton = hildon.Button (gtk.HILDON_SIZE_AUTO_WIDTH | gtk.HILDON_SIZE_AUTO_HEIGHT, 
			hildon.BUTTON_ARRANGEMENT_HORIZONTAL, "Save as...")
savebutton.connect("clicked", save_file)
table.attach(savebutton, 0, 2, 3, 4)
counterbutton = hildon.PickerButton (gtk.HILDON_SIZE_AUTO_WIDTH | gtk.HILDON_SIZE_AUTO_HEIGHT, 
			hildon.BUTTON_ARRANGEMENT_HORIZONTAL)
def selection_changed_maxpics(select_maxpics, data):
    maxpics = select_maxpics.get_current_text()
    MaxPics.append(maxpics)
    counterbutton.set_label(maxpics)
select_maxpics = hildon.TouchSelector(14)
select_maxpics.append_text("2")
select_maxpics.append_text("3")
select_maxpics.append_text("4")
select_maxpics.append_text("5")
select_maxpics.append_text("10")
select_maxpics.append_text("15")
select_maxpics.append_text("20")
select_maxpics.append_text("30")
select_maxpics.append_text("40")
select_maxpics.append_text("50")
select_maxpics.append_text("100")
select_maxpics.append_text("200")
select_maxpics.append_text("500")
select_maxpics.append_text("1000")
select_maxpics.connect("changed", selection_changed_maxpics)
counterbutton.set_selector(select_maxpics)
counterbutton.set_label("Counter")
table.attach(counterbutton, 1, 2, 0, 1)
viewerbutton = gtk.ToggleButton("Viewfinder")
viewerbutton.connect("toggled", toggle_viewfinder)
table.attach(viewerbutton, 0, 1, 1, 2)
capturebutton = gtk.ToggleButton("Automatic")
capturebutton.connect("toggled", toggle_capture)
table.attach(capturebutton, 1, 2, 1, 2)
manualbutton = gtk.Button("Manual")
manualbutton.connect("clicked", manual_capture)
table.attach(manualbutton, 1, 2, 2, 3)
convertbutton = gtk.Button("PyTimelapseMaker")
convertbutton.connect("clicked", convert)
table.attach(convertbutton, 0, 2, 4, 5)
table.attach(ViewFinder, 2, 4, 0, 5)
win.connect("destroy", gtk.main_quit, None)
win.show_all()
gtk.main()

if __name__ == "__main__":
    main()
